
function cookietoggle_switchCookie() {
	var m_prefs = Components.classes["@mozilla.org/preferences-service;1"].
		getService(Components.interfaces.nsIPrefService).
		getBranch("network.cookie.");
	var nCurCookieBehavior = m_prefs.getIntPref("cookieBehavior");
	if (nCurCookieBehavior == 2) {
		cookietoggle_setOn();
	} else if ((nCurCookieBehavior == 1) ||(nCurCookieBehavior == 0)) {
		cookietoggle_setOff();
	}
}

function cookietoggle_init() {
	var m_prefs = Components.classes["@mozilla.org/preferences-service;1"].
		getService(Components.interfaces.nsIPrefService).
		getBranch("network.cookie.");
	var m_prefs2 = Components.classes["@mozilla.org/preferences-service;1"].
		getService(Components.interfaces.nsIPrefService).
		getBranch("extensions.cookietoggle.");
	var nCurCookieBehavior = m_prefs.getIntPref("cookieBehavior");
	if (!m_prefs2.prefHasUserValue("cookieBehavior")) {
		if (nCurCookieBehavior == 2) {
			m_prefs2.setIntPref("cookieBehavior", 0);
		}
		else {
			m_prefs2.setIntPref("cookieBehavior", nCurCookieBehavior);
		}
	}
	if (nCurCookieBehavior == 2) {
		cookietoggle_setOff();
	} else if ((nCurCookieBehavior == 0) || (nCurCookieBehavior == 1)) {
		cookietoggle_setOn();
	}
}


function cookietoggle_setOn() {
	var cookietoggleStrings;
	var m_button = document.getElementById("cookietoggle-button");
	var m_prefs = Components.classes["@mozilla.org/preferences-service;1"].
		getService(Components.interfaces.nsIPrefService).
		getBranch("network.cookie.");
	var m_prefs2 = Components.classes["@mozilla.org/preferences-service;1"].
		getService(Components.interfaces.nsIPrefService).
		getBranch("extensions.cookietoggle.");
	var nVarCookieBehavior = m_prefs2.getIntPref("cookieBehavior");
	m_prefs.setIntPref("cookieBehavior", nVarCookieBehavior);

	if (document.getElementById("navigator-toolbox").getAttribute("iconsize")=='small') {
		m_button.setAttribute('image', 'chrome://cookietoggle/skin/CookieToggle20x20.png');
		m_button.setAttribute('tooltiptext', cookietoggleStrings.getstring("cookiesoff"));
	} else {
		m_button.setAttribute('image', 'chrome://cookietoggle/skin/CookieToggle32x32.png');
		m_button.setAttribute('tooltiptext', cookietoggleStrings.getstring("cookiesoff"));
	}
}

function cookietoggle_setOff() {
	var cookietoggleStrings;
	var m_button = document.getElementById("cookietoggle-button");
	var m_prefs = Components.classes["@mozilla.org/preferences-service;1"].
		getService(Components.interfaces.nsIPrefService).
		getBranch("network.cookie.");
	var m_prefs2 = Components.classes["@mozilla.org/preferences-service;1"].
		getService(Components.interfaces.nsIPrefService).
		getBranch("extensions.cookietoggle.");
	var nCurCookieBehavior = m_prefs.getIntPref("cookieBehavior");
	if (nCurCookieBehavior != 2) {
		m_prefs2.setIntPref("cookieBehavior", nCurCookieBehavior);
	}
	m_prefs.setIntPref("cookieBehavior", 2);

	if (document.getElementById("navigator-toolbox").getAttribute("iconsize")=='small') {
		m_button.setAttribute('image', 'chrome://cookietoggle/skin/CookieToggleOff20x20.png');
		m_button.setAttribute('tooltiptext', cookietoggleStrings.getstring("cookieson"));
	} else {
		m_button.setAttribute('image', 'chrome://cookietoggle/skin/CookieToggleOff32x32.png');
		m_button.setAttribute('tooltiptext', cookietoggleStrings.getstring("cookieson"));
	}
}


